﻿Imports System
Imports System.Diagnostics
Imports System.Threading

Public Class Measure_speed

    Dim trackLength As Integer
    Dim timeMin As Integer = 0
    Dim timeSec As Integer = 0
    Dim timeHun As Integer = 0
    Dim Time As New DateTime
    Dim min As Integer
    Dim sec As Integer
    Dim hun As Integer
    Dim minstr As String
    Dim secstr As String
    Dim hunstr As String
    Dim minprev As Integer
    Dim secprev As Integer
    Dim hunprev As Integer
    Dim NumberofLaps As Integer = 0
    Dim Timeprev As Integer
    Dim averageSpeed As Single
    Dim avtime As String
    Dim speed As Single

    Private Sub rbtTrackOne_CheckedChanged(sender As Object, e As EventArgs) Handles rbtTrackOne.CheckedChanged

        txbInput.Text = ""
        txbInput.Enabled = False
        trackLength = 4144
        btnStartStop.Enabled = True
        lblLengthofTrack.Text = "Length of track: " & trackLength & " mm"

    End Sub

    Private Sub rbtTrackTwo_CheckedChanged(sender As Object, e As EventArgs) Handles rbtTrackTwo.CheckedChanged

        txbInput.Text = ""
        txbInput.Enabled = False
        trackLength = 4018
        btnStartStop.Enabled = True
        lblLengthofTrack.Text = "Length of track: " & trackLength & " mm"

    End Sub

    Private Sub rbtInput_CheckedChanged(sender As Object, e As EventArgs) Handles rbtInput.CheckedChanged

        txbInput.Enabled = True
        btnStartStop.Enabled = False

    End Sub

    Private Sub txbInput_TextChanged(sender As Object, e As EventArgs) Handles txbInput.TextChanged

        If (txbInput.Text = "") Then

            lblLengthofTrack.Text = "Length of track: "
            btnStartStop.Enabled = False

        ElseIf (IsNumeric(txbInput.Text)) Then

            trackLength = txbInput.Text
            lblLengthofTrack.Text = "Length of track: " & trackLength & " mm"
            btnStartStop.Enabled = True

        Else

            txbInput.Text = ""

        End If

    End Sub

    Private Sub tmrTime_Tick(sender As Object, e As EventArgs) Handles tmrTime.Tick

        timeHun += 1

        If (timeHun = 100) Then

            timeSec += 1
            timeHun = 0

        End If
        If (timeSec = 60) Then

            timeMin += 1
            timeSec = 0

        End If

        Dim Difference As TimeSpan = DateTime.Now.Subtract(Time)

        min = Difference.Minutes.ToString
        sec = Difference.Seconds.ToString
        hun = Difference.Milliseconds.ToString

        If (min < 10) Then

            minstr = "0" & min

        Else

            minstr = min

        End If

        If (sec < 10) Then

            secstr = "0" & sec

        Else

            secstr = sec

        End If

        If (hun < 10) Then

            hunstr = "00" & hun

        ElseIf (hun < 100) Then

            hunstr = "0" & hun

        Else

            hunstr = hun

        End If

        lblTimeMin.Text = "Time: " & minstr & ":" & secstr & ":" & hunstr

    End Sub

    Private Sub btnStartStop_Click(sender As Object, e As EventArgs) Handles btnStartStop.Click

        If (cbxAverage.Checked = True) Then

            If (btnStartStop.Text = "Start") Then

                timeMin = 0
                timeSec = 0
                timeHun = 0

                Time = DateTime.Now
                tmrTime.Start()
                btnStartStop.Text = "Stop"
                btnLap.Enabled = True
                btnCalculate.Enabled = True
                NumberofLaps = 0
                btnSave.Enabled = False
                lblSpeed.Text = "Speed: 0.0 m/s"
                tbxAverage.Clear()
                tbxAverage.AppendText("Lap:" & vbTab & "Time:" & vbTab & vbTab & "Speed lap:" & vbCrLf)


            ElseIf (btnStartStop.Text = "Stop") Then

                tmrTime.Stop()
                btnStartStop.Text = "Start"
                btnLap.Enabled = False

            End If

        Else

            If (btnStartStop.Text = "Start") Then

                timeMin = 0
                timeSec = 0
                timeHun = 0

                Time = DateTime.Now
                tmrTime.Start()
                btnStartStop.Text = "Stop"
                btnCalculate.Enabled = True
                btnSave.Enabled = False
                lblSpeed.Text = "Speed: 0.0 m/s"

            ElseIf (btnStartStop.Text = "Stop") Then

                tmrTime.Stop()
                btnStartStop.Text = "Start"

            End If

        End If

    End Sub

    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click

        Dim MetersPerSecond As Single
        Dim Time As Integer

        If (cbxAverage.Checked = True) Then

            Linefollower.lblMperS.Text = speed & " m/s"
            btnSave.Enabled = False
            btnCalculate.Enabled = False

            Linefollower.speed = speed
            Linefollower.average = "Yes"
            Linefollower.laps = NumberofLaps
            Linefollower.track = trackLength.ToString
            Linefollower.time = avtime

        Else

            Time = calculateTime()
            MetersPerSecond = CalculateSpeed(Time)
            Linefollower.lblMperS.Text = MetersPerSecond & " m/s"
            btnSave.Enabled = False
            btnCalculate.Enabled = False

            Linefollower.speed = MetersPerSecond
            Linefollower.average = "No"
            Linefollower.laps = 1
            Linefollower.track = trackLength.ToString
            Linefollower.time = min & ":" & sec & ":" & hun

        End If

    End Sub

    Function calculateTime()

        Dim TimeLap As Integer

        TimeLap = ((((min * 60) + sec) * 1000) + hun)

        Return TimeLap

    End Function

    Function CalculateSpeed(Timela)

        Dim MpS As Single = 0.00

        MpS = trackLength / Timela

        MpS = Math.Round(MpS, 2, MidpointRounding.AwayFromZero)

        Return MpS

    End Function

    Private Sub btnLap_Click(sender As Object, e As EventArgs) Handles btnLap.Click

        Dim MetersPerSecond As Single

        NumberofLaps += 1

        If (btnStartStop.Text = "Start") Then

            btnLap.Enabled = False

        End If

        If (NumberofLaps = 1) Then

            'no prev time
            Dim LapTime As Integer

            LapTime = ((((min * 60) + sec) * 1000) + hun)

            MetersPerSecond = CalculateSpeed(LapTime)

            averageSpeed = MetersPerSecond

            tbxAverage.AppendText(NumberofLaps & vbTab & min & ":" & sec & ":" & hun & vbTab & vbTab & MetersPerSecond & vbCrLf)

        ElseIf (NumberofLaps = 10) Then

            'last lap
            Dim LapTime As Integer

            LapTime = ((((min * 60) + sec) * 1000) + hun) - Timeprev

            MetersPerSecond = CalculateSpeed(LapTime)

            Dim minnow As Integer
            Dim secnow As Integer
            Dim hunnow As Integer

            minnow = min - minprev
            secnow = sec - secprev

            If (hun >= hunprev) Then

                hunnow = hun - hunprev

            Else

                hunnow = 1000 - hunprev
                secnow = secnow - 1

            End If

            averageSpeed = averageSpeed + MetersPerSecond

            tbxAverage.AppendText(NumberofLaps & vbTab & minnow & ":" & secnow & ":" & hunnow & vbTab & vbTab & MetersPerSecond & vbCrLf)

            btnCalculate.PerformClick()

            tmrTime.Stop()
            tbxAverage.Enabled = False
            btnLap.Enabled = False
            btnStartStop.PerformClick()

        Else

            'code
            Dim LapTime As Integer

            LapTime = ((((min * 60) + sec) * 1000) + hun) - Timeprev

            MetersPerSecond = CalculateSpeed(LapTime)

            Dim minnow As Integer
            Dim secnow As Integer
            Dim hunnow As Integer

            minnow = min - minprev
            secnow = sec - secprev

            If (hun >= hunprev) Then

                hunnow = hun - hunprev

            Else

                hunnow = 1000 - hunprev
                secnow = secnow - 1

            End If

            averageSpeed = averageSpeed + MetersPerSecond

            tbxAverage.AppendText(NumberofLaps & vbTab & minnow & ":" & secnow & ":" & hunnow & vbTab & vbTab & MetersPerSecond & vbCrLf)

        End If

        Timeprev = ((((min * 60) + sec) * 1000) + hun)
        minprev = min
        secprev = sec
        hunprev = hun

    End Sub

    Private Sub cbxAverage_CheckedChanged(sender As Object, e As EventArgs) Handles cbxAverage.CheckedChanged

        If (cbxAverage.Checked = True) Then

            tbxAverage.Enabled = True

        Else

            tbxAverage.Enabled = False

        End If

    End Sub

    Private Sub btnCalculate_Click(sender As Object, e As EventArgs) Handles btnCalculate.Click

        If (cbxAverage.Checked = True) Then

            avtime = calcAvtime(NumberofLaps, minprev, secprev, hunprev)

            speed = averageSpeed / NumberofLaps

            speed = Math.Round(speed, 2, MidpointRounding.AwayFromZero)

            tbxAverage.AppendText("Total time: " & minprev & ":" & secprev & ":" & hunprev & vbCrLf & "Laps: " & NumberofLaps & vbCrLf & "Average lap time: " & avtime & vbCrLf & "Average speed: " & speed & " m/s" & vbCrLf)

            lblSpeed.Text = "Speed: " & speed & " m/s"
            btnSave.Enabled = True
        Else

            Dim MetersPerSecond As Single
            Dim Time As Integer

            Time = calculateTime()
            MetersPerSecond = CalculateSpeed(Time)
            lblSpeed.Text = "Speed: " & MetersPerSecond & " m/s"
            btnSave.Enabled = True
            btnSave.Enabled = True

        End If

    End Sub

    Function calcAvtime(numberofLaps, minprev, secprev, hunprev)

        Dim tottime As Single
        Dim avmin As Single
        Dim avsec As Single
        Dim avhun As Single
        Dim avtime As String

        'making sure all the time values are in seconds
        avmin = minprev * 60
        avsec = secprev
        avhun = hunprev / 1000

        'Total value devideing by total laps and round to 3 after the decimal
        tottime = avmin + avsec + avhun
        tottime = tottime / numberofLaps
        tottime = Math.Round(tottime, 3, MidpointRounding.AwayFromZero)

        'reform the time values to minutes, seconds and millis
        avmin = Int(Int(tottime) / 60)
        avsec = Int(tottime - avmin * 60)
        avhun = Int((tottime - Int(tottime)) * 1000)

        'putting the values into a string and returning it
        avtime = avmin & ":" & avsec & ":" & avhun

        Return avtime

    End Function

End Class