﻿Imports System
Imports System.IO.Ports

Public Class Serial_monitor

    Dim defaultBaudrate As Integer = 115200
    Dim receivedData As String

    Private Sub Serial_monitor_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Me.Text = "Serial monitor " + Linefollower.comPortOut
        tmrCheckData.Enabled = True

        tbxSerialMonitor.AppendText(vbCrLf & "Configuring serial ports" & vbCrLf)
        tbxSerialMonitor.AppendText("BaudRate: " & Linefollower.Baudrate & vbCrLf)
        tbxSerialMonitor.AppendText("DataBits: 8" & vbCrLf)
        tbxSerialMonitor.AppendText("StopBits: 1" & vbCrLf)
        tbxSerialMonitor.AppendText("Handshake: None" & vbCrLf)
        tbxSerialMonitor.AppendText("Parity: None" & vbCrLf & vbCrLf)

    End Sub

    Private Sub tbxSendCommand_Keydown(sender As Object, e As KeyEventArgs) Handles tbxSendCommand.KeyDown

        If (e.KeyCode.Equals(Keys.Enter)) Then

            btnSend.PerformClick()

        End If

    End Sub

    Private Sub btnSend_Click(sender As Object, e As EventArgs) Handles btnSend.Click

        Dim Line As String = "****************************************************************************************************************"

        Try

            If (tbxSendCommand.Text = "clear") Then

                tbxSerialMonitor.Clear()

            ElseIf (tbxSendCommand.Text = "check") Then

                If (Linefollower.BluethOut.IsOpen) Then

                    tbxSerialMonitor.AppendText("Bluethooth Serial communication is open" & vbCrLf)
                    tbxSerialMonitor.AppendText("Baudrate is: " & Linefollower.Baudrate & vbCrLf)

                    If (tmrCheckData.Enabled = True) Then

                        tbxSerialMonitor.AppendText("Serial monitor is activated." & vbCrLf)

                    Else

                        tbxSerialMonitor.AppendText("Serial monitor is deactivated" & vbCrLf)

                    End If

                Else

                    tbxSerialMonitor.AppendText("Bluethooth Serial communication is closed" & vbCrLf)
                    tbxSerialMonitor.AppendText("Baudrate is: " & Linefollower.Baudrate & vbCrLf)
                    tbxSerialMonitor.AppendText("Serial monitor is deactivated" & vbCrLf)

                End If

            ElseIf (tbxSendCommand.Text = "startSerial") Then

                If (Linefollower.BluethOut.IsOpen) Then

                    tmrCheckData.Start()
                    tbxSerialMonitor.AppendText("Serial monitor has started." & vbCrLf)

                Else

                    tbxSerialMonitor.AppendText("Can not start Serial monitor for there is no connection via bluetooth." & vbCrLf)

                End If

            ElseIf (tbxSendCommand.Text = "stopSerial") Then

                tmrCheckData.Stop()
                tbxSerialMonitor.AppendText("Serial monitor has stopped." & vbCrLf)


            ElseIf (tbxSendCommand.Text = "open") Then

                Linefollower.tsmiConnect.PerformClick()

            ElseIf (tbxSendCommand.Text = "close") Then

                Linefollower.tsmiDisconnect.PerformClick()

            ElseIf (tbxSendCommand.Text = "default baudrate") Then

                Linefollower.Baudrate = defaultBaudrate
                tbxSerialMonitor.AppendText("Baudrate set to default" & vbCrLf)

            ElseIf (tbxSendCommand.Text = "shutdown") Then

                tmrCheckData.Stop()
                Linefollower.BluethOut.Close()
                Linefollower.Close()

            ElseIf (tbxSendCommand.Text = "fullshutdown") Then

                Linefollower.BluethOut.WriteLine("stop" & vbCrLf)
                tmrCheckData.Stop()
                Linefollower.BluethOut.Close()
                Linefollower.Close()

            ElseIf (tbxSendCommand.Text = "help") Then

                tbxSerialMonitor.AppendText(Line & vbCrLf)
                tbxSerialMonitor.AppendText("Possible commands for debugging the Serial monitor:" & vbCrLf)
                tbxSerialMonitor.AppendText("clear" & vbTab & vbTab & "-->" & vbTab & "Erase everything from the Serial monitor." & vbCrLf)
                tbxSerialMonitor.AppendText("check" & vbTab & vbTab & "-->" & vbTab & "Checking for bluetooth connection." & vbCrLf)
                tbxSerialMonitor.AppendText("startSerial" & vbTab & vbTab & "-->" & vbTab & "Start checking for incomming Serial data." & vbCrLf)
                tbxSerialMonitor.AppendText("stopSerial" & vbTab & vbTab & "-->" & vbTab & "Stop checking for incomming Serial data." & vbCrLf)
                tbxSerialMonitor.AppendText("open" & vbTab & vbTab & "-->" & vbTab & "Opening bluetooth Serial." & vbCrLf)
                tbxSerialMonitor.AppendText("close" & vbTab & vbTab & "-->" & vbTab & "Closing bluetooth Serial." & vbCrLf)
                tbxSerialMonitor.AppendText("default" & vbTab & vbTab & "-->" & vbTab & "Setting the baudrate to default " & defaultBaudrate & "." & vbCrLf)
                tbxSerialMonitor.AppendText("getEEPROM" & vbTab & "-->" & vbTab & "Show the values in EEPROM of the linefollower." & vbCrLf)
                tbxSerialMonitor.AppendText("shutdown" & vbTab & vbTab & "-->" & vbTab & "Close the program." & vbCrLf)
                tbxSerialMonitor.AppendText("fullshutdown" & vbTab & "-->" & vbTab & "Close the program and stop the linefollower." & vbCrLf)
                tbxSerialMonitor.AppendText("commands" & vbTab & "-->" & vbTab & "Show possible commands for controlling the linefollower." & vbCrLf)
                tbxSerialMonitor.AppendText(Line & vbCrLf)

            ElseIf (tbxSendCommand.Text = "commands") Then

                tbxSerialMonitor.AppendText(Line & vbCrLf)
                tbxSerialMonitor.AppendText("Possible commands for the linefollower:" & vbCrLf)
                tbxSerialMonitor.AppendText("start" & vbTab & vbTab & vbTab & "-->" & vbTab & "Start driving." & vbCrLf)
                tbxSerialMonitor.AppendText("stop" & vbTab & vbTab & vbTab & "-->" & vbTab & "Stop drinving." & vbCrLf)
                tbxSerialMonitor.AppendText("set <arg> <value>" & vbTab & vbTab & "-->" & vbTab & "Set the value of the speed or cycletime." & vbCrLf)
                tbxSerialMonitor.AppendText("debug" & vbTab & vbTab & vbTab & "-->" & vbTab & "Show values that can be used to find an error." & vbCrLf)
                tbxSerialMonitor.AppendText("reset" & vbTab & vbTab & vbTab & "-->" & vbTab & "Resetting the values." & vbCrLf)
                tbxSerialMonitor.AppendText("ManBest <arg>" & vbTab & vbTab & "-->" & vbTab & "Manual drive controll." & vbCrLf)
                tbxSerialMonitor.AppendText("PID <value> <value> <value>" & vbTab & "-->" & vbTab & "Send PID values Kp Ki Kd." & vbCrLf)
                tbxSerialMonitor.AppendText("WriteToEEPROM" & vbTab & vbTab & "-->" & vbTab & "Write all values to EEPROM memmory." & vbCrLf)
                tbxSerialMonitor.AppendText("Calibrate <arg>" & vbTab & vbTab & "-->" & vbTab & "Calibrate sensors to white or black" & vbCrLf)
                tbxSerialMonitor.AppendText("getEEPROM" & vbTab & vbTab & "-->" & vbTab & "Show the values in EEPROM of linefollower." & vbCrLf)
                tbxSerialMonitor.AppendText("Status" & vbTab & vbTab & vbTab & "-->" & vbTab & "Show status of the linefollower." & vbCrLf)
                tbxSerialMonitor.AppendText("zero" & vbTab & vbTab & vbTab & "-->" & vbTab & "Reset the linefollower to zero when driven of line" & vbCrLf)
                tbxSerialMonitor.AppendText(Line & vbCrLf)

            Else

                Dim text As String = tbxSendCommand.Text

                Linefollower.BluethOut.WriteLine(text & vbCrLf)

            End If

            tbxSendCommand.Clear()

            tbxSerialMonitor.ScrollToCaret()

        Catch ex As Exception

            Dim result As DialogResult

            result = MessageBox.Show("Connection lost." & vbCrLf & "Ceck if bluetooth device is on." & vbCrLf & "Try to reconnect?", "ERROR", MessageBoxButtons.YesNo, MessageBoxIcon.Error)

            If (result = DialogResult.No) Then

                Linefollower.connectionLost()

            Else

                Linefollower.connectionLost()
                Linefollower.tsmiConnect.PerformClick()

            End If

        End Try

    End Sub

    Private Sub tmrCheckData_Tick(sender As Object, e As EventArgs) Handles tmrCheckData.Tick

        receivedData = ReceivedSerialData()
        tbxSerialMonitor.AppendText(receivedData)
        tbxSerialMonitor.AppendText("")
        tbxSerialMonitor.ScrollToCaret()

    End Sub

    Function ReceivedSerialData() As String

        Dim Incoming As String

        Try

            Incoming = Linefollower.BluethOut.ReadExisting()

            If Incoming Is Nothing Then

                Return "nothing" & vbCrLf

            Else

                Return Incoming

            End If

        Catch ex As Exception

            Linefollower.tsmiDisconnect.PerformClick()
            tmrCheckData.Stop()
            Return "ERROR: Connection lost. Forced shutdown!" & vbCrLf & "Serial monitor Stopped." & vbCrLf


        End Try

    End Function

End Class